unit USample;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, AdvChartView, AdvChartViewGDIP, AdvChart,
  ExtCtrls, Buttons, TeEngine, Series, TeeProcs, Chart, ComCtrls;

type
  TForm21 = class(TForm)
    Button1: TButton;
    AdvGDIPChartView1: TAdvGDIPChartView;
    pnlTop: TPanel;
    pnlLeft: TPanel;
    pnlRight: TPanel;
    pnlBottom: TPanel;
    edtPointsCount: TEdit;
    pgc1: TPageControl;
    tsTms: TTabSheet;
    tsVcl: TTabSheet;
    Chart1: TChart;
    Series1: TLineSeries;
    btn2: TBitBtn;
    chkEnableInteraction: TCheckBox;
    procedure btn2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure AdvGDIPChartView1GetNumberOfPoints(Sender: TObject; Pane, Serie: Integer; var ANumberOfPoints: Integer);
    procedure AdvGDIPChartView1GetPoint(Sender: TObject; Pane, Serie, AIndex: Integer; var APoint: TChartPoint);
  public
  end;

var
  Form21: TForm21;

implementation

{$R *.dfm}

uses
  DateUtils;

var
  baseDateTime: TDateTime;
  pointsCount: Integer;

procedure TForm21.AdvGDIPChartView1GetNumberOfPoints(Sender: TObject; Pane, Serie: Integer; var ANumberOfPoints: Integer);
begin
  ANumberOfPoints := pointsCount;
end;

function ConvertDateTimeToX(Date: TDateTime): Double;
begin
  Result := MilliSecondsBetween(Date, baseDateTime) / 1000;
end;

procedure TForm21.AdvGDIPChartView1GetPoint(Sender: TObject; Pane, Serie, AIndex: Integer; var APoint: TChartPoint);
begin
  APoint.TimeStamp := IncSecond(baseDateTime, AIndex);
  APoint.SingleXValue := ConvertDateTimeToX(APoint.TimeStamp);
  if AIndex = 3 then
  begin
    APoint.TimeStamp := IncMilliSecond(baseDateTime, (AIndex * 1000) + 350);
    APoint.SingleXValue := ConvertDateTimeToX(APoint.TimeStamp);
  end;

  case Serie of
    0: APoint.SingleValue := 210 + Random(10);
    1: APoint.SingleValue := sqrt(AIndex);
    2: APoint.SingleValue := 190 - Random(10);
  end;
end;

procedure TForm21.btn2Click(Sender: TObject);
var
  i: Integer;
  iPoints: Integer;
begin
  iPoints := StrToIntDef(edtPointsCount.Text, 0);
  for i := 0 to iPoints do
    Series1.Add(Random(1000));
end;

procedure TForm21.Button1Click(Sender: TObject);
begin
  AdvGDIPChartView1.EnableInteraction := chkEnableInteraction.Checked;

  AdvGDIPChartView1.OnGetPoint := AdvGDIPChartView1GetPoint;
  AdvGDIPChartView1.OnGetNumberOfPoints := AdvGDIPChartView1GetNumberOfPoints;

  baseDateTime := Now;
  pointsCount := StrToIntDef(edtPointsCount.Text, 0);

  AdvGDIPChartView1.BeginUpdate;
  with AdvGDIPChartView1.Panes[0] do
  begin
    Series.Clear;
    Series.Add;
    Series.Add;
    Series.Add;
    XAxis.UnitType := utSecond;
    XAxis.Size := 130;
    YAxis.Position := yBoth;
    Title.Size := 50;
    Title.Font.Size := 16;
    XScaleOffset := False;

    Range.StartDate := baseDateTime;
    with Series[0] do
    begin
      XAxis.Visible := True;
      YAxis.Visible := True;
      AutoRange := arCommon;
      ChartType := ctXYLine;
      LineColor := clBlue;
      XAxis.TextBottom.Angle := 90;
      XAxis.AutoUnits := True;
      XAxis.XYValues := False;
      XAxis.MajorUnitTimeFormat := 'dd/mm/yyyy hh:nn:ss:zzz';
    end;

    with Series[1] do
    begin
      XAxis.Visible := False;
      YAxis.Position := yRight;
      YAxis.Visible := True;
      AutoRange := arEnabled;
      LineColor := clGreen;
      ChartType := ctXYLine;
      XAxis.TextBottom.Angle := 90;
      XAxis.AutoUnits := True;
      XAxis.XYValues := False;
    end;

    with Series[2] do
    begin
      XAxis.Visible := False;
      YAxis.Visible := False;
      AutoRange := arCommon;
      LineColor := clBlack;
      ChartType := ctXYLine;
      XAxis.TextBottom.Angle := 90;
      XAxis.AutoUnits := True;
      XAxis.XYValues := False;
    end;
    Range.RangeTo := pointsCount - 1;
  end;
  AdvGDIPChartView1.EndUpdate;
end;

end.
